#include "aulaworker.h"

/*AulaWorker::AulaWorker(QObject *parent): QThread{parent}{

}*/


void AulaWorker::aula(){

    /*
  printf("TEST\n========Au=La=====================================================================\n");
  printf(
      "        .-\"-~-\"-.\n"
      "       /.-\"-.-\"-.\\\n"
      "       ||((o|o))||\n"
      "       )\\__/V\\__/(\n"
      "      / ~ -...- ~ \\\n"
      "     |\\` ~. ~ .~ `/|\n"
      "     | `~ - ^ - ~` |\n"
      "     | ;  '  :  .  |\n"
      "      \\ . : '  ; '/\n"
      "       '.   ; ' .'\n"
      "        `uu---uu`\n");*/
    inventNewLabels(chain);
    possible=0;
    for (int i=0; i<_w->mole.asymm.size(); i++) if (_w->mole.asymm.at(i).an>=0) possible++;
    QFile res(_w->dirName);
    res.open(QIODevice::ReadOnly|QIODevice::Text);
    all = QString(res.readAll());
    res.close();
    QStringList newlabels;
    int partmin=0;
    int partmax=0;
    for (int i=0; i<chain.size(); i++){
        int das = chain.at(i);
        partmin = qMin(partmin, _w->mole.asymm.at(das).part);
        partmax = qMax(partmax, _w->mole.asymm.at(das).part);
        QString old = _w->mole.asymm.at(das).Label;
        int j=1;
        int rn=(useResis)?_w->mole.asymm.at(das).molindex:0;
        QString nl=QString("%1%2_%3").arg(_w->mole.pse(_w->mole.asymm.at(das).an)).arg(j).arg(rn);
        while (newlabels.contains(nl)) nl=QString("%1%2_%3").arg(_w->mole.pse(_w->mole.asymm.at(das).an)).arg(++j).arg(rn);
        newlabels.append(nl);
        if (useResis){
            _w->mole.asymm[das].resiNr = rn;
            _w->mole.asymm[das].ResiClass = QString("M%1").arg(rn);
        }
        _w->mole.asymm[das].Label = nl.section('_',0,0);
    }
    newlabels.clear();
    emit message("New labels created.");
    int firstatom = all.indexOf(_w->mole.asymm.at(0).orginalLine);
    int firstpart = all.indexOf("\nPART",0,Qt::CaseInsensitive);
    int firstresi = all.indexOf("\nRESI",0,Qt::CaseInsensitive);
    int vonhier = firstatom;
    if (firstpart>-1) vonhier = qMin(vonhier,firstpart);
    if (firstresi>-1) vonhier = qMin(vonhier,firstresi);

    int bisda =all.lastIndexOf("\nHKLF");
    _w->editor->sortAtoms(_w->mole.asymm);
    QString insert = "\n";
    int pr=0,pp=0;
    for (int i=0; i<_w->mole.asymm.size(); i++){
        int das = i;
        int _sfacnr = 1 + _w->editor->sfac.indexOf(_w->mole.asymm.at(das).an);
        if ((useResis)&&(pr!=_w->mole.asymm.at(das).molindex)) {
            insert+=QString("RESI %1 M%2\n").arg(_w->mole.asymm.at(das).molindex).arg(_w->mole.asymm.at(das).molindex);
            pr=_w->mole.asymm.at(das).molindex;
        }
        if (((partmin<0)||(partmax>0))&&(pp!=_w->mole.asymm.at(das).part)) {
            insert+=QString("PART %1\n").arg(_w->mole.asymm.at(das).part);
            pp=_w->mole.asymm.at(das).part;
        }
        if (_w->mole.asymm.at(das).isIso)
            insert+=QString("%1 %2 %3 %4 %5 %6 %7\n")
                          .arg(_w->mole.asymm.at(das).Label,-4)
                          .arg(_sfacnr)
                          .arg(_w->mole.asymm.at(das).frac.x,10,'f',5)
                          .arg(_w->mole.asymm.at(das).frac.y,10,'f',5)
                          .arg(_w->mole.asymm.at(das).frac.z,10,'f',5)
                          .arg(_w->mole.asymm.at(das).sof_org,10,'f',5)
                          .arg(_w->mole.asymm.at(das).ufiso_org)
                ;
        else
            //         0.01902    0.00464    0.01485   -0.00203
            insert+=QString("%1 %2 %3 %4 %5 %6 %7 %8 =\n      %9 %10 %11 %12\n")
                          .arg(_w->mole.asymm.at(das).Label,-4)
                          .arg(_sfacnr)
                          .arg(_w->mole.asymm.at(das).frac.x,10,'f',5)
                          .arg(_w->mole.asymm.at(das).frac.y,10,'f',5)
                          .arg(_w->mole.asymm.at(das).frac.z,10,'f',5)
                          .arg(_w->mole.asymm.at(das).sof_org,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m11,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m22,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m33,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m32,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m31,10,'f',5)
                          .arg(_w->mole.asymm.at(das).uf.m21,10,'f',5)
                ;

    }
    all.replace(vonhier,bisda-vonhier,insert);
    emit message("...old labeld atoms replaced with new ones...");

}

void AulaWorker::extendChain(QList<Ring> &rings,QList<int> &currentChain, QList<QList<int> > &neighbors,QSet<int> &nogo){
    int last=currentChain.last();
    for (int ri=0; ri<rings.size();ri++){
        if (rings.at(ri).done) continue;
        if (rings[ri].members.contains(last)){
            int bbv=currentChain.size();
            int strt=rings[ri].members.indexOf(last);
            for (int rri=0,rrj=0; rri<rings[ri].members.size(); rri++){
                rrj=(strt>=0)?(strt+rri)%rings[ri].members.size():rri;
                if (!currentChain.contains(rings[ri].members.at(rrj))) currentChain.append(rings[ri].members.at(rrj));
            }
            bbv-=currentChain.size();
            if (bbv) {
                rings[ri].done=true;
            }
        }
    }
    if (neighbors.at(last).size()==1) return;
    QList<int> c;
    int ic=-1;
    int manb=0;
    for (int i=0; i<neighbors.at(last).size(); i++){
        if (currentChain.contains(neighbors.at(last).at(i))) continue;
        if (nogo.contains(neighbors.at(last).at(i))) continue;
        int z=neighbors.at(neighbors.at(last).at(i)).size();
        if(z>manb){
            manb=z;
            ic=i;
        }
    }
    if (ic!=-1){
        c=currentChain;
        currentChain.append(neighbors.at(last).at(ic));
        extendChain(rings, currentChain, neighbors, nogo);
    }
    c.clear();
}

void AulaWorker::inventNewLabels(QList<int> &result){

    /*
   * Idea / draft:
   * for atoms in a molecule
   * find chain ends  (E) neighbors 1
   * find chain atoms (C) neighbors 2
   * find nodes       (N) neighbors >2
   * start at an E and append indexes to a QList chain
   * when a node N appears copy the list neighbors - 1 times (forking)
   * when no atoms left then compare number members in each chain
   * the longest chain wins
   * the longest part with carbons wins
   * the E with the greatest distance from center of mass wins
   * E-C-C-C-N-C-C-N-N-N-C-C-E
   *         |     | | |
   *         C-C-C-C E E
   *
   * 1-2-3-4-5-g-h-a-b-c-d-e-f
   *         |     | | |
   *         6-7-8-9 i j
   */
    //return;
    QList<QList<int> > neighbors;
    QList<QList<int> > chains;
    QList<int> emptyChain;
    QSet<int> nogo;
    QList<int> molsizes;
    QList<bool> moleIsDone;
    QList<double> avan, di2com;// avarage atomic number, distance to center of mass
    QList<V3> centerOfMass;
    QList<int>cmax;//maximal chain length
    for (int i=0; i<_w->mole.asymm.size(); i++){
        if (_w->mole.asymm.at(i).an<0 )continue;
        neighbors.append(emptyChain);
        if (_w->mole.asymm.at(i).molindex < 0) printf("_w->mole.asymm.at(i).molindex = %d\n",_w->mole.asymm.at(i).molindex);
        if (_w->mole.asymm.at(i).molindex> molsizes.size()) {
            molsizes.append(0);
            cmax.append(0);
            moleIsDone.append(false);
            centerOfMass.append(V3(0.0,0.0,0.0));
            avan.append(999990.0);
            di2com.append(0.0);
        }
        molsizes[_w->mole.asymm.at(i).molindex-1]++;
        centerOfMass[_w->mole.asymm.at(i).molindex-1]+=_w->mole.asymm.at(i).pos;
    }
    for (int i=0; i<molsizes.size(); i++){
        centerOfMass[i]*=1.0/molsizes.at(i);
    }
    for (int i=0; i<_w->mole.sdm.size(); i++){
        if ((_w->mole.sdm.at(i).a1>=neighbors.size())||(_w->mole.sdm.at(i).a2>=neighbors.size())) continue;
        if (_w->mole.sdm.at(i).covalent) neighbors[_w->mole.sdm.at(i).a1].append(_w->mole.sdm.at(i).a2);
    }
    // find rings first
    QList<QList<int> > rings;
    QList<Tripel> tripels;
    Tripel t;//midcenter
    QList<Ring> ringe;
    QSet<int>nonMetals;
    emit message("find rings...");
    //B, C, N, O, F,  Si, P, S, Cl, Ge, As, Se, Br,  Sb, Te, I
    nonMetals<<4<<5<<6<<7<<8<<13<<14<<15<<16<<31<<32<<33<<34<<50<<51<<52;
    for (int i=0; i<neighbors.size();i++){
        if (!nonMetals.contains(_w->mole.asymm.at(i).an)) continue; //no rings with metals
        if (neighbors.at(i).size()>1)
            for (int j=0; j<neighbors.at(i).size();j++){
                for (int k=j+1; k<neighbors.at(i).size();k++){
                    if (!nonMetals.contains(_w->mole.asymm.at(neighbors.at(i).at(j)).an)) continue; //no rings with metals
                    if (!nonMetals.contains(_w->mole.asymm.at(neighbors.at(i).at(k)).an)) continue; //no rings with metals
                    t.n[0]=i;
                    t.n[1]=neighbors.at(i).at(j);
                    t.n[2]=neighbors.at(i).at(k);
                    double w = _w->mole.winkel(_w->mole.asymm.at(t.n[1]).pos - _w->mole.asymm.at(t.n[0]).pos,
                                               _w->mole.asymm.at(t.n[2]).pos - _w->mole.asymm.at(t.n[0]).pos) / 180.0 * M_PI;
                    double scal = sin(w * 0.5) * sin(w * 0.5) / (sin(w) * sin(w));
                    t.midcenter = _w->mole.asymm.at(t.n[0]).pos + scal * (_w->mole.asymm.at(t.n[1]).pos +
                                                                          _w->mole.asymm.at(t.n[2]).pos -(_w->mole.asymm.at(t.n[0]).pos * 2.0));
                    tripels.append(t);
                }
            }
    }
    const double RINGTEST=0.7;
    for (int i=0; i<tripels.size(); i++){
        for (int j=0; j<i; j++){
            double dist=Distance(tripels.at(i).midcenter,tripels.at(j).midcenter);
            if (dist<RINGTEST){
                bool alreadyHaveIt=false;
                for (int k = 0; k < ringe.size(); k++){
                    V3 r1=ringe[k].theCenter();
                    double
                        d1=Distance(tripels.at(i).midcenter,r1),
                        d2=Distance(tripels.at(j).midcenter,r1);
                    if ((d1<RINGTEST)||(d2<RINGTEST)){
                        ringe[k].addTripel(tripels.at(i));
                        ringe[k].addTripel(tripels.at(j));
                        alreadyHaveIt=true;
                        //  continue;
                    }
                }
                if (!alreadyHaveIt){
                    ringe.append(Ring(tripels.at(i),tripels.at(j)));
                }
            }
        }
    }
    emit message(QString("found %1 rings.").arg(ringe.size()));
    for (int ri=0; ri<ringe.size(); ri++){
        bool fertig = ringe[ri].isComplete();
        if ((!fertig)&&(ringe[ri].members.size()<7)) {
            int u=ringe[ri].members.size();
            for (int w=0; w<u; w++) {
                for (int v=0; v<tripels.size();v++){
                    if (
                        (ringe[ri].members.contains(tripels.at(v).n[0]))&&
                        (ringe[ri].members.contains(tripels.at(v).n[1]))&&
                        (ringe[ri].members.contains(tripels.at(v).n[2]))) {
                        ringe[ri].addTripel(tripels.at(v));
                        continue;
                    }
                }
            }
        }
        //ringe[ri].printRing(this);
        fertig = ringe[ri].isComplete();
        ringe[ri].isItARealRing();
        fertig = ringe[ri].isComplete();
        if (!fertig) {ringe.removeAt(ri);ri--;}
    }
    emit message(QString("found %1 rings.").arg(ringe.size()));
    //  return;
    for (int mi=0; mi<centerOfMass.size();mi++){
        double away=-10.0;
        int itakethisring=0;
        for (int ri=0; ri<ringe.size(); ri++){
            if ((_w->mole.asymm.at(ringe.at(ri).members.at(0)).molindex-1)!=mi) continue;
            if (ringe.at(ri).members.size()==7){
                ringe[ri].debugRing(&_w->mole);
                ringe[ri].isItARealRing();
            }
            double d=Distance(centerOfMass[_w->mole.asymm.at(ringe.at(ri).members.at(0)).molindex-1],ringe[ri].theCenter());
            V3 dir = (_w->mole.asymm.at(ringe.at(ri).members.at(0)).pos -
                      ringe[ri].theCenter())%(_w->mole.asymm.at(ringe.at(ri).members.at(1)).pos - ringe[ri].theCenter());
            V3 com2r = ringe[ri].theCenter()-centerOfMass[_w->mole.asymm.at(ringe.at(ri).members.at(0)).molindex-1];
            double test= dir*com2r;
            QList<int> rcpy=ringe[ri].members;
            if (test>0.0){//flip ring order
                ringe[ri].members.clear();
                for (int kk=rcpy.size()-1; kk>=0; kk--){
                    ringe[ri].members.append(rcpy.at(kk));
                }
                dir = (_w->mole.asymm.at(ringe.at(ri).members.at(0)).pos -
                       ringe[ri].theCenter())%(_w->mole.asymm.at(ringe.at(ri).members.at(1)).pos - ringe[ri].theCenter());
                test= dir*com2r;
            }
            if (away<d){
                away=d;
                itakethisring=ri;
            }
        }
        emit message(QString("found %1 rings.").arg(ringe.size()));
        if ((!ringe.isEmpty())&&((_w->mole.asymm.at(ringe.at(itakethisring).members.at(0)).molindex-1)==mi)){
            int starthere=0,mn=0;
            double away2=1000;
            for (int i=0; i<ringe[itakethisring].members.size(); i++){
                if ((neighbors.at(ringe[itakethisring].members.at(i)).size()>=mn)&&
                    (Distance(_w->mole.asymm.at(ringe[itakethisring].members.at(i)).pos,centerOfMass[_w->mole.asymm.at(ringe.at(itakethisring).members.at(i)).molindex-1])<away2)){
                    mn=neighbors.at(ringe[itakethisring].members.at(i)).size();
                    away2=Distance(_w->mole.asymm.at(ringe[itakethisring].members.at(i)).pos,centerOfMass[_w->mole.asymm.at(ringe.at(itakethisring).members.at(i)).molindex-1]);
                    starthere=i;
                }
            }
            chains.append(emptyChain);
            for (int i=0; i<ringe[itakethisring].members.size(); i++){
                chains.last().append(ringe[itakethisring].members.at(starthere%ringe[itakethisring].members.size()));
                starthere++;
            }
            ringe[itakethisring].done=true;
            //aneal ring
            for (int ci=0; ci<chains.last().size(); ci++){
                for (int ri=0; ri<ringe.size();ri++){
                    if (ringe.at(ri).done) continue;
                    if ((ringe[ri].members.contains(chains.last().at(ci)))&&(ringe[ri].members.contains(chains.last().at((ci+1)%chains.last().size())))){
                        int bbv=chains.last().size();
                        int ll=chains.last().last();
                        int strt=ringe[ri].members.indexOf(ll);
                        if (strt<0)strt = ringe[ri].members.indexOf(chains.last().at(ci));
                        for (int rri=0,rrj=0; rri<ringe[ri].members.size(); rri++){
                            rrj=(strt>=0)?(strt+rri)%ringe[ri].members.size():rri;
                            if (!chains.last().contains(ringe[ri].members.at(rrj))) chains.last().append(ringe[ri].members.at(rrj));
                        }
                        bbv-=chains.last().size();
                        if (bbv) ringe[ri].done=true;
                    }
                }
            }
            do{
                int ce=chains.last().size();
                for (int cc=0; cc<ce; cc++){
                    for (int nn=0; nn<neighbors.at(chains.last().at(cc)).size();nn++){
                        if (!chains.last().contains(neighbors.at(chains.last().at(cc)).at(nn))) {
                            chains.last().append(neighbors.at(chains.last().at(cc)).at(nn));
                            extendChain(ringe,chains.last(), neighbors,nogo);
                        }
                    }
                }
            }while(chains.last().size()<molsizes.at(mi));
            if (chains.last().size()==molsizes.at(mi))moleIsDone[mi]=true;
        }
        if ((!chains.isEmpty())&&(!result.contains(chains.last().last()))) {
            result.append(chains.last());
        }
    }//mi

    emit message(QString("Molecules with rings are done."));
    for (int mi=0; mi<molsizes.size(); mi++){
        if (moleIsDone.at(mi)) continue;
        int starthere=-1;
        double away=-10;
        for (int i=0; i<neighbors.size(); i++){
            if (_w->mole.asymm.at(i).an<0)continue;
            if ((_w->mole.asymm.at(i).molindex-1 == mi)&&(neighbors.at(i).size()==0)){
                result.append(i);//isolated atoms
                continue;
            }
            if ((_w->mole.asymm.at(i).molindex-1 == mi)&&(neighbors.at(i).size()==1)){//chain end
                double d=Distance(_w->mole.asymm.at(i).pos,centerOfMass.at(mi));
                if (d>away){
                    away=d;
                    starthere=i;
                }
            }
        }
        if (starthere<0) continue;

        if (!result.contains(starthere)){
            chains.append(emptyChain);
            chains.last().append(starthere);
            extendChain(ringe,chains.last(),neighbors,nogo);
        }
        do{
            int ce=chains.last().size();
            for (int cc=0; cc<ce; cc++){
                for (int nn=0; nn<neighbors.at(chains.last().at(cc)).size();nn++){
                    if (!chains.last().contains(neighbors.at(chains.last().at(cc)).at(nn))) {
                        chains.last().append(neighbors.at(chains.last().at(cc)).at(nn));
                        extendChain(ringe,chains.last(), neighbors,nogo);
                    }
                }
            }
        }while(chains.last().size()<molsizes.at(mi));
        if ((!chains.isEmpty())&&(!result.contains(chains.last().last()))) {
            result.append(chains.last());
        }

    }
    for (int cs=0; cs<chains.size(); cs++){
        chains[cs].clear();
    }
    chains.clear();
    emit message("All chains are done!");
}

void AulaWorker::finalize(){
    _w->editor->setPlainText(all);
    all.clear();
    _w->fileSave();
    _w->chgl->update();
    _w->fileSave();
    QWhatsThis::hideText();
    QMessageBox mb2(QMessageBox::Information,
                    "Automatic Labeling",QString("<h4>Labeled %1 atoms out of %2 atoms in the asymmetic unit in %3 seconds </h4>")
                        .arg(chain.size()).arg(possible).arg((rzeit.elapsed()/1000.0),0,'f',1));
    mb2.exec();
}
