#ifndef AULAWORKER_H
#define AULAWORKER_H

#include <QThread>
#include <QMainWindow>
#include "window.h"

class AulaWorker : public QThread{
    Q_OBJECT
public:
    explicit AulaWorker(Window *parent, bool ur){
        _w = parent;
        useResis = ur;
        rzeit.start();
    }
    void run() override {
        /* expensive or blocking operation  */
        aula();
    }
    Window *_w;
    bool saveruf;
    int possible;
    QList<int> chain;
    void aula();
    bool useResis;
public slots:
    void finalize();
signals:
    void message(const QString &);//!< small text messages to the status bar.
    void rename(int);
private:
    QElapsedTimer rzeit;
    QString all;
    void extendChain(QList<Ring > &rings, QList<int> &currentChain, QList<QList<int> > &neighbors,QSet<int> &nogo);
    void inventNewLabels(QList<int> &result);
};
#endif // AULAWORKER_H
