#include "savehistorywidget.h"
#include "deprecation.h"
#include <QScrollArea>
#include <QDialogButtonBox>
#include <QSplitter>
#include "itsme.h"

SaveHistoryWidget::SaveHistoryWidget(QString filename, bool _dark, QWidget *parent  ):QDialog(parent){
  pvindex=-1;
  fileName=filename;
  dark=_dark;
  //dda = new DragDropVersions(filename,dark,parent);
  tableWidget = new QTableWidget(5, 2, this);

  QString dn = filename.section('/',0,-2);
  QString argument = filename.section('/',-1);
  tableWidget->setHorizontalHeaderItem(0, new QTableWidgetItem(argument));
  tableWidget->setHorizontalHeaderItem(1, new QTableWidgetItem("Date saved"));
  //QStringList filenames;

  QString saveHistName = QString("%1/%2saves/SAVEHIST").arg(dn).arg(PROGRAM_NAME);
  QFile sahi(saveHistName);
  sahi.open(QIODevice::ReadOnly|QIODevice::Text);
  QString Alles=sahi.readAll();//Entry|@|2011-03-08T13:32:19|@|b11.res|@|
  sahi.close();
  QRegularExpression re = QRegularExpression("Entry\\|@\\|\\w+-\\w+-\\w+:\\w+:\\w+\\|@\\|[^@]+@\\|");
  entries = Alles.split(re,skipEmptyParts);
  QRegularExpressionMatchIterator matchiterator = re.globalMatch(Alles);
  QDateTime nowis = QFileInfo(filename).lastModified();
  fileNameByDate[nowis] = filename.section('/',-1);
  tableWidget->setRowCount(entries.size()+1);
  int irow = 1;
  while (matchiterator.hasNext()) {
      QString recap0 = matchiterator.next().captured();
      QDateTime t0 = QDateTime::fromString(recap0.section('|',2,2),Qt::ISODate);
      zeiten.append(t0);
      QString nam;
      fileNameByDate[t0] = nam = recap0.section('|',4,4);
      QString snam = filename.section('/',-1);
      //qDebug()<<nam<<snam<<(nam==snam)<<irow;
      if (nam==snam){
      QTableWidgetItem *itm = new TableWidgetItem(t0.toString(Qt::RFC2822Date));//"HH:mm:ss - MM-dd-yyyy ttt"));
      itm->setData(Qt::UserRole, zeiten.last());
      tableWidget->setItem(irow, 1, itm);
      itm = new QTableWidgetItem(fileNameByDate.value(zeiten.last()));
      itm->setData(Qt::UserRole, zeiten.last());
      tableWidget->setItem(irow, 0, itm);
      irow++;
      }
  }
  //qDebug()<<zeiten.first()<<zeiten.last();
  tableWidget->setRowCount(irow);
  TableWidgetItem *currentitm = new TableWidgetItem("current file version");
  currentitm->setData(Qt::UserRole, nowis);
  tableWidget->setItem(0, 0, currentitm);
  currentitm = new TableWidgetItem("current");
  currentitm->setData(Qt::UserRole, nowis);
  tableWidget->setItem(0, 1, currentitm);
  tableWidget->resizeColumnsToContents();
  tableWidget->setSortingEnabled(true);
  tableWidget->sortItems(1);
  tableWidget->setCurrentItem(currentitm);
  tableWidget->scrollToItem(currentitm);
  QScrollArea *preview = new QScrollArea();
  QGridLayout *pvla = new QGridLayout();
  pvheader = new QLabel("<h3>current file version</h3>");
  pvheader->setText(QString("<h3>current file version of %1 %2</h3>").arg(nowis.toString()).arg(fileNameByDate.value(nowis)));
  curheader = new QLabel("<h3>current file version</h3>");
  curheader->setText(QString("<h3>current file version of %1 %2</h3>").arg(nowis.toString()).arg(fileNameByDate.value(nowis)));
  if (dark){
    pvheader->setStyleSheet (QString(
        "QLabel{font: bold; border: 2px solid #2f2f31; border-radius: 1px;background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #007700, stop: 1 #424242);} "
        "QLabel:hover {background-color: qlineargradient(x1: 0, y1: 0, x2: 1, y2: 0," "stop: 0 #242424, stop: 1 #007700);border: 2px solid #eeeeee;}"));
    curheader->setStyleSheet (QString(
          "QLabel{font: bold; border: 2px solid #2f2f31; border-radius: 1px;background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #007700, stop: 1 #424242);} "
          "QLabel:hover {background-color: qlineargradient(x1: 0, y1: 0, x2: 1, y2: 0," "stop: 0 #242424, stop: 1 #007700);border: 2px solid #eeeeee;}"));
  }else{
    pvheader->setStyleSheet (QString(
        "QLabel{font: bold; border: 2px solid #2f2f31; border-radius: 1px;background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #aaeeaa, stop: 1 #dadbde);} "
        "QLabel:hover {background-color: qlineargradient(x1: 0, y1: 0, x2: 1, y2: 0," "stop: 0 #ffffff, stop: 1 #aaee00);border: 2px solid #eeeeee;}"));
    curheader->setStyleSheet (QString(
        "QLabel{font: bold; border: 2px solid #2f2f31; border-radius: 1px;background-color: qlineargradient(x1: 0, y1: 0, x2: 0, y2: 1,stop: 0 #aaeeaa, stop: 1 #dadbde);} "
        "QLabel:hover {background-color: qlineargradient(x1: 0, y1: 0, x2: 1, y2: 0," "stop: 0 #ffffff, stop: 1 #aaee00);border: 2px solid #eeeeee;}"));

  }
  edi = new CodeEditor();
  edi->dark=dark;
  curedi = new CodeEditor();
  curedi->dark=dark;
  QString inspatternfile=(dark)?":ins_res_style_dark.ini":":ins_res_style.ini";
  edi->highlighter->loadHighlightPatterns(inspatternfile);
  curedi->highlighter->loadHighlightPatterns(inspatternfile);
  QFont font;
  font.setFamily(FONTFAM);
  font.setFixedPitch(true);
  font.setPointSize(9);
  edi->setFont(font);
  edi->setLineWrapMode(QPlainTextEdit::NoWrap);
  curedi->setFont(font);
  curedi->setLineWrapMode(QPlainTextEdit::NoWrap);
  QFile p(filename);

  p.open(QIODevice::ReadOnly|QIODevice::Text);
  edi->setPlainText(orginal = p.readAll());
  curedi->setPlainText(orginal);
  p.close();
  pvla->addWidget(pvheader,  0 ,0, 1, 1);
  pvla->addWidget(curheader, 0 ,1, 1, 1);
  pvla->addWidget(edi,    1, 0, 1, 1);
  pvla->addWidget(curedi, 1, 1, 1, 1);
  edi->setReadOnly ( true);  
  curedi->setReadOnly ( true);
  preview->setLayout(pvla);
  QDialogButtonBox *buttonBox = new QDialogButtonBox(QDialogButtonBox::Open | QDialogButtonBox::Cancel);
  ok = buttonBox->button(QDialogButtonBox::Open);

  ok->setDisabled(true);
  connect(buttonBox, SIGNAL(accepted()), this, SLOT(accept()));
  connect(buttonBox, SIGNAL(rejected()), this, SLOT(reject()));
  QHBoxLayout *la = new QHBoxLayout();
  QVBoxLayout *lo = new QVBoxLayout();
  QSplitter *splitter = new QSplitter(parent);
  splitter->addWidget(tableWidget);
  splitter->addWidget(preview);
  splitter->setChildrenCollapsible (false);
  splitter->setStretchFactor(1, 2);
  QList<int> szs;
  szs<<350<<500;
  splitter->setSizes(szs);
  la->addWidget(splitter);
  lo->addLayout(la);
  lo->addWidget(buttonBox);
  setLayout(lo);
  connect(tableWidget, &QTableWidget::currentCellChanged, this, &SaveHistoryWidget::updatePreview);
  setWindowTitle(tr("Save History"));
  this->setWindowState(Qt::WindowMaximized);
}

void SaveHistoryWidget::updatePreview(int row, int column, int prw, int pco){
  QDateTime _when = tableWidget->currentItem()->data(Qt::UserRole).toDateTime();
  int idx = zeiten.indexOf(_when);
  //printf(" %d  %d  %d  %d  index = %d %d %d\n", row, column, prw, pco, idx,entries.size(),zeiten.size());
  if ((idx>=0)&&(idx<entries.size())) {
    pvheader->setText(QString("<h3>%1  %2</h3>").arg(zeiten.at(idx).toString()).arg(fileNameByDate.value(zeiten.at(idx))));
    pvindex=idx;
    QString ext = entries.at(idx);
    ext.remove(QRegularExpression("^\n"));
    curedi->setReadOnly(false);
    curedi->setPlainText(orginal);
    curedi->diffTo(ext);
    curedi->setReadOnly(true);
    edi->setReadOnly(false);
    edi->setPlainText(ext);
    edi->diffTo(orginal);
    edi->setReadOnly(true);
  }
  else {
    pvindex=-1;
    QDateTime nowis = QFileInfo(fileName).lastModified();

    pvheader->setText(QString("<h3>current file version of %1 %2</h3>").arg(nowis.toString()).arg(fileNameByDate.value(nowis)));
    edi->setReadOnly(false);
    QFile p(fileName);
    p.open(QIODevice::ReadOnly|QIODevice::Text);
    QString ext = p.readAll();
    p.close();
    edi->setPlainText(ext);
    edi->diffTo(orginal);
    curedi->setReadOnly(false);
    curedi->setPlainText(orginal);
    curedi->diffTo(ext);
    curedi->setReadOnly(true);
    edi->setReadOnly(true);
  }
  tock();
}


void SaveHistoryWidget::tock(){
  if ((pvindex!=-1)&&(pvindex<zeiten.size())){
    bool fine=(fileNameByDate.value(zeiten.at(pvindex))!=fileName.section('/',-1));
    pvheader->setText(QString("<h3>%1 %2 %3 %4</h3>")
                          .arg(zeiten.at(pvindex).toString())
                          .arg(fileNameByDate.value(zeiten.at(pvindex)))
                          .arg((fine)?"<font color=\"red\">entry filename differs from current filename!</font>":"")
                          .arg(fileName.section('/',-1))
                      );
    ok->setDisabled(fine);
  }else ok->setDisabled(true);
  //printf("%d %d\n", pvindex, zeiten.size());
}

void SaveHistoryWidget::accept(){
  QFile f(fileName);

  f.open(QIODevice::ReadOnly|QIODevice::Text);
  QString alterScheis=f.readAll();
  QFileInfo fi(f);
  f.close();

  bool success = f.open(QIODevice::WriteOnly|QIODevice::Text);
  if (success){
    f.write(edi->toPlainText().toLatin1());
    f.close();
    QString dn=fileName.section('/',0,-2),
            argument=fileName.section('/',-1);
    QDir work=QDir(QString("%1/%2saves/").arg(dn).arg(PROGRAM_NAME));
    if (!work.exists ( QString("%1/%2saves/").arg(dn).arg(PROGRAM_NAME))) work.mkdir (QString("%1/%2saves/").arg(dn).arg(PROGRAM_NAME));
    QString saveHistName=QString("%1/%2saves/SAVEHIST").arg(dn).arg(PROGRAM_NAME);
    QFile sahi(saveHistName);
    sahi.open(QIODevice::Append|QIODevice::Text);
    sahi.write(QString("Entry|@|%1|@|%2|@|\n").arg(fi.lastModified().toString(Qt::ISODate)).arg(argument).toLatin1());
    sahi.write(alterScheis.toLatin1());
  }
  done(QDialog::Accepted);
}
