#ifndef SAVEHISTORYWIDGET_H
#define SAVEHISTORYWIDGET_H

#include <QtGui>
#include <QDialog>
#include <QPushButton>
#include <QLabel>

#include <QTableWidget>
#include "codeeditor.h"
class TableWidgetItem: public QTableWidgetItem{
public:
    explicit TableWidgetItem(const QString &text, int _type = Type) : QTableWidgetItem(text,_type){
    }
protected:
    bool operator<(const QTableWidgetItem &other) const override{
        QDateTime left = this->data(Qt::UserRole).toDateTime();
        QDateTime right = other.data(Qt::UserRole).toDateTime();
        return left<right;
    }
};
//! SaveHistoryWidget is a QDialog to load and compare earlier versions of the res file. 
class SaveHistoryWidget : public QDialog {
Q_OBJECT
public:
    SaveHistoryWidget(QString filename, bool _dark, QWidget *parent = nullptr);
    QPushButton * ok;//!> the ok button 
    bool dark;
//signals:
public slots:
    void tock();
    void updatePreview(int row, int column, int prw, int pco);
	void accept();  
  private:
    int pvindex;
    CodeEditor *edi;  //!> Editor for the save history file difference.
    CodeEditor *curedi;
    QLabel *pvheader;    
    QLabel *curheader;
    //DragDropVersions *dda;
    QTableWidget *tableWidget;

    QStringList entries, headers;
    QMap<QDateTime, QString> fileNameByDate;
    QList<QDateTime> zeiten;
    QString fileName,orginal;
};
#endif

