#ifndef SHORTESDISTANCEMATRIX_H
#define SHORTESDISTANCEMATRIX_H

#include <QThread>
#include <QMainWindow>
#include "window.h"

class ShortesDistanceMatrix : public QThread{
    Q_OBJECT
public:
    explicit ShortesDistanceMatrix(Window *parent = nullptr);
    Window *_w;

    QStringList brauchSymm;
    void run() override {
        /* expensive or blocking operation  */
        csdm();
    }
    void csdm();
    void enviSDM(double range);
public slots:
    void finalize();
signals:
    void message(const QString &);//!< small text messages to the status bar.
private:

    QList<SdmItem> sdm;//!< shortest distance matrix.
    QList<SdmItem> envi_sdm;//!< shortest distance matrix for the ENVIron ment listing functionality.
    QList<SdmItem> contact;//!< shortest distance matrix with possible hydrogen bonds for auto HFIX.
    void neighborSort(Knopf &kn);
};

#endif // SHORTESDISTANCEMATRIX_H
